/***************************************************************************
 *
 * Copyright (c) 2000, 2001 BalaBit IT Ltd, Budapest, Hungary
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 * $Id: packsock.h,v 1.2.6.2.2.1 2002/06/27 12:07:37 sasa Exp $
 *
 ***************************************************************************/

#ifndef ZORP_PACKSOCK_H_INCLUDED
#define ZORP_PACKSOCK_H_INCLUDED

#include <zorp/sockaddr.h>

typedef struct _ZorpCHeader
{
  struct sockaddr_in from;
  struct sockaddr_in to;
} ZorpCHeader;
    
typedef struct _ZPacket
{
  ZorpCHeader packheader;
  gint length;
  guchar *data;
  gpointer opaque_data;
} ZPacket;
            

int z_packsock_send(ZPacket *packet, guint socket,
                   struct sockaddr_in *xfrom, struct sockaddr_in *xto);
                                 
gboolean z_packsock_receive(int fd, ZPacket *packet);

#endif
