/***************************************************************************
 *
 * COPYRIGHTHERE
 *
 * $Id: socket.h,v 1.1.4.1 2002/08/26 07:58:27 sasa Exp $
 *
 ***************************************************************************/

#ifndef ZORP_SOCKET_H_INCLUDED
#define ZORP_SOCKET_H_INCLUDED

#include <zorp/zorp.h>
#include <zorp/sockaddr.h>

typedef struct _ZSocketFuncs
{
  gint (*bind)(int fd, struct sockaddr *sa, socklen_t salen);
  gint (*accept)(int fd, struct sockaddr *sa, socklen_t *salen);
  gint (*connect)(int fd, struct sockaddr *sa, socklen_t salen);
  gint (*listen)(int fd, gint backlog, gboolean accept_one);
  gint (*getsockname)(int fd, struct sockaddr *sa, socklen_t *salen);
  gint (*getpeername)(int fd, struct sockaddr *sa, socklen_t *salen);
} ZSocketFuncs;

gint z_do_ll_bind(int fd, struct sockaddr *sa, socklen_t salen);
gint z_do_ll_accept(int fd, struct sockaddr *sa, socklen_t *salen);
gint z_do_ll_connect(int fd, struct sockaddr *sa, socklen_t salen);
gint z_do_ll_listen(int fd, gint backlog, gboolean accept_one);
gint z_do_ll_getsockname(int fd, struct sockaddr *sa, socklen_t *salen);
gint z_do_ll_getpeername(int fd, struct sockaddr *sa, socklen_t *salen);


extern ZSocketFuncs z_socket_funcs;
extern ZSocketFuncs *socket_funcs;

static inline gint
z_ll_bind(gint fd, struct sockaddr *sa, socklen_t salen)
{
  return socket_funcs->bind(fd, sa, salen);
}

static inline gint 
z_ll_accept(gint fd, struct sockaddr *sa, socklen_t *salen)
{
  return socket_funcs->accept(fd, sa, salen);
}

static inline gint 
z_ll_connect(gint fd, struct sockaddr *sa, socklen_t salen)
{
  return socket_funcs->connect(fd, sa, salen);
}

static inline gint
z_ll_listen(gint fd, gint backlog, gboolean accept_one)
{
  return socket_funcs->listen(fd, backlog, accept_one);
}

static inline gint
z_ll_getsockname(gint fd, struct sockaddr *sa, socklen_t *salen)
{
  return socket_funcs->getsockname(fd, sa, salen);
}

static inline gint
z_ll_getpeername(gint fd, struct sockaddr *sa, socklen_t *salen)
{
  return socket_funcs->getpeername(fd, sa, salen);
}

GIOError z_bind(gint fd, ZSockAddr *addr);
GIOError z_accept(gint fd, gint *newfd, ZSockAddr **addr);
GIOError z_connect(gint fd, ZSockAddr *remote);
GIOError z_listen(gint fd, gint backlog, gboolean accept_one);
GIOError z_getsockname(gint fd, ZSockAddr **local_addr);
GIOError z_getpeername(gint fd, ZSockAddr **peer_addr);

#endif
